加载中...
117-填充每个节点的下一个右侧节点指针 II(Populating Next Right Pointers in Each Node II)
发表于:2021-12-03 | 分类: 中等
字数统计: 424 | 阅读时长: 2分钟 | 阅读量:

原文链接: https://leetcode-cn.com/problems/populating-next-right-pointers-in-each-node-ii

英文原文

Given a binary tree

struct Node {
  int val;
  Node *left;
  Node *right;
  Node *next;
}

Populate each next pointer to point to its next right node. If there is no next right node, the next pointer should be set to NULL.

Initially, all next pointers are set to NULL.

 

Example 1:

Input: root = [1,2,3,4,5,null,7]
Output: [1,#,2,3,#,4,5,7,#]
Explanation: Given the above binary tree (Figure A), your function should populate each next pointer to point to its next right node, just like in Figure B. The serialized output is in level order as connected by the next pointers, with '#' signifying the end of each level.

Example 2:

Input: root = []
Output: []

 

Constraints:

  • The number of nodes in the tree is in the range [0, 6000].
  • -100 <= Node.val <= 100

 

Follow-up:

  • You may only use constant extra space.
  • The recursive approach is fine. You may assume implicit stack space does not count as extra space for this problem.

中文题目

给定一个二叉树

struct Node {
  int val;
  Node *left;
  Node *right;
  Node *next;
}

填充它的每个 next 指针,让这个指针指向其下一个右侧节点。如果找不到下一个右侧节点,则将 next 指针设置为 NULL

初始状态下,所有 next 指针都被设置为 NULL

 

进阶:

  • 你只能使用常量级额外空间。
  • 使用递归解题也符合要求,本题中递归程序占用的栈空间不算做额外的空间复杂度。

 

示例:

输入:root = [1,2,3,4,5,null,7]
输出:[1,#,2,3,#,4,5,7,#]
解释:给定二叉树如图 A 所示,你的函数应该填充它的每个 next 指针,以指向其下一个右侧节点,如图 B 所示。序列化输出按层序遍历顺序(由 next 指针连接),'#' 表示每层的末尾。

 

提示:

  • 树中的节点数小于 6000
  • -100 <= node.val <= 100

 

通过代码

高赞题解

1,BFS解决

看到关于二叉树的问题,首先要想到关于二叉树的一些常见遍历方式,

对于二叉树的遍历有

  1. 前序遍历

  2. 中序遍历

  3. 后续遍历

  4. 深度优先搜索(DFS)

  5. 宽度优先搜索(BFS)

除了上面介绍的5种以外,还有Morris(莫里斯)的前中后3种遍历方式,总共也就这8种。所以只要遇到二叉树相关的算法题,首先想到的就是上面的几种遍历方式,然后再稍加修改,基本上也就这个套路。

这题让求的就是让把二叉树中每行都串联起来,对于这道题来说最适合的就是BFS。也就是一行一行的遍历,如下图所示

image.png

他的代码如下


public void levelOrder(TreeNode tree) {

    if (tree == null)

        return;

    Queue<TreeNode> queue = new LinkedList<>();

    queue.add(tree);//相当于把数据加入到队列尾部

    while (!queue.isEmpty()) {

        //poll方法相当于移除队列头部的元素

        TreeNode node = queue.poll();

        System.out.println(node.val);

        if (node.left != null)

            queue.add(node.left);

        if (node.right != null)

            queue.add(node.right);

    }

}

在遍历每一行的时候,只要把他们串联起来就OK,下面就来把上面的代码改造一下


public Node connect(Node root) {

    if (root == null)

        return root;

    Queue<Node> queue = new LinkedList<>();

    queue.add(root);

    while (!queue.isEmpty()) {

        //每一层的数量

        int levelCount = queue.size();

        //前一个节点

        Node pre = null;

        for (int i = 0; i < levelCount; i++) {

            //出队

            Node node = queue.poll();

            //如果pre为空就表示node节点是这一行的第一个,

            //没有前一个节点指向他,否则就让前一个节点指向他

            if (pre != null) {

                pre.next = node;

            }

            //然后再让当前节点成为前一个节点

            pre = node;

            //左右子节点如果不为空就入队

            if (node.left != null)

                queue.add(node.left);

            if (node.right != null)

                queue.add(node.right);

        }

    }

    return root;

}

看一下运行结果

image.png


上面运行效率并不是很高,这是因为我们把节点不同的入队然后再不停的出队,其实可以不需要队列,每一行都可以看成一个链表比如第一行就是只有一个节点的链表,第二行是只有两个节点的链表(假如根节点的左右两个子节点都不为空)……

image.png

image.png


public Node connect(Node root) {

    if (root == null)

        return root;

    //cur我们可以把它看做是每一层的链表

    Node cur = root;

    while (cur != null) {

        //遍历当前层的时候,为了方便操作在下一

        //层前面添加一个哑结点(注意这里是访问

        //当前层的节点,然后把下一层的节点串起来)

        Node dummy = new Node(0);

        //pre表示访下一层节点的前一个节点

        Node pre = dummy;

        //然后开始遍历当前层的链表

        while (cur != null) {

            if (cur.left != null) {

                //如果当前节点的左子节点不为空,就让pre节点

                //的next指向他,也就是把它串起来

                pre.next = cur.left;

                //然后再更新pre

                pre = pre.next;

            }

            //同理参照左子树

            if (cur.right != null) {

                pre.next = cur.right;

                pre = pre.next;

            }

            //继续访问这一行的下一个节点

            cur = cur.next;

        }

        //把下一层串联成一个链表之后,让他赋值给cur,

        //后续继续循环,直到cur为空为止

        cur = dummy.next;

    }

    return root;

}

看一下运行结果

image.png


我把部分算法题整理成了PDF文档,截止目前总共有900多页,大家可以下载阅读

链接https://pan.baidu.com/s/1hjwK0ZeRxYGB8lIkbKuQgQ

提取码:6666

如果觉得有用就给个赞吧,还可以关注我的LeetCode主页查看更多的详细题解

统计信息

通过次数 提交次数 AC比率
99607 160885 61.9%

提交历史

提交时间 提交结果 执行时间 内存消耗 语言

相似题目

题目 难度
填充每个节点的下一个右侧节点指针 中等
上一篇:
116-填充每个节点的下一个右侧节点指针(Populating Next Right Pointers in Each Node)
下一篇:
118-杨辉三角(Pascal's Triangle)
本文目录
本文目录